/* EOTemplateGenerator.h created by mgentry on Mon 14-Jun-1999 */

#import <Foundation/Foundation.h>

@class EOEntity;
@class EOModel;

typedef enum _ArgumentType {
    ArgumentInvalidOption = -1,
    ArgumentUnknownOption = 0,
    ArgumentVersion 	= 1,
    ArgumentHelp,
    ArgumentVerbose,
    ArgumentDelim,
    ArgumentStartDelim,
    ArgumentEndDelim,
    ArgumentForce,
    ArgumentModel,
    ArgumentRefModel,
    ArgumentTemplateDir,
    ArgumentTemplate,
    ArgumentDestination,
    ArgumentExtension,
    ArgumentFile,
    ArgumentIndexFile,
    ArgumentGroupDoc,
    ArgumentModelDoc,
    ArgumentEntityDoc,
    ArgumentEntityList,
    ArgumentListFormat,
    ArgumentListSeparator,
    ArgumentDefine,
    ArgumentJava,
    ArgumentGenericEntityOnly,
    ArgumentConcreteEntityOnly
} ArgumentType;

typedef enum _FormatOrder {
    EntityFirst = 1,
    ModelFirst
} EOFormatOrder;

@interface EOTemplateGenerator : NSObject
{
    NSMutableArray *searchPaths;
    NSMutableArray *entityNames;
    NSMutableArray *entityWildcards;
    NSMutableArray *models;
    NSMutableDictionary *userVariables;

    NSString *delimStart;
    NSString *delimEnd;

    BOOL verboseMode;
    BOOL forceOverwrites;
    BOOL indexFile;
    BOOL javaMode;

    int listEntityTypes;
    NSString *listFormat;
    NSString *listSeparator;
    int listFormatOrder;
    
    int docMode;
    NSString *docDestination;
    NSString *docTemplate;
    NSString *docExtension;
    NSString *docFile;
}

- init;
- (void)displayHelpAndExit:(int)exitStatus;
- (void)processCommandLineArguments;

- (void)generate;
- (void)generateGroupDoc;
- (void)generateModelDoc;
- (void)generateEntityDoc;
- (void)generateEntityList;

@end
