//
//    _MiscMergeWhileCommand.m 
//      Written by Carl Lindberg Copyright 2000 by Carl Lindberg.
//                       All rights reserved.
//        This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	
//  This file formatted with 4 spaces per tabstop.

#import "_MiscMergeWhileCommand.h"
#import <Foundation/NSString.h>
#import "MiscMergeCommandBlock.h"
#import "MiscMergeCondition.h"

@implementation _MiscMergeWhileCommand

- init
{
    [super init];
    commandBlock = [[MiscMergeCommandBlock alloc] initWithOwner:self];
    return self;
}

- (void)dealloc
{
    [condition release];
    [commandBlock release];
    [super dealloc];
}

- (BOOL)parseFromScanner:(NSScanner *)aScanner template:(MiscMergeTemplate *)template
{
    [self eatKeyWord:@"while" fromScanner:aScanner isOptional:NO];

    condition = [[self getConditionFromScanner:aScanner] retain];

    [template pushCommandBlock:commandBlock];

    return YES;
}

- (void)handleEndWhileInTemplate:(MiscMergeTemplate *)template
{
    [template popCommandBlock:commandBlock];
}

- (void)executeForMerge:(MiscMergeEngine *)aMerger
{
    while ([condition evaluateWithEngine:aMerger])
    {
        [aMerger executeCommandBlock:commandBlock];
    }
}

@end
